package RDF::Simple::Resource;
use strict;
use CGI::Carp;
use Data::Dumper;
use vars qw( @ISA );

@ISA = qw( );  # Defined by constructor


sub model { $_[0]->{'model'} }

sub new
{
    my( $class, $model ) = @_;

    my $source = $model->{'source'}{'name'};
    my $source_mod  = "RDF::Source::".$source."::Resource";
    my $source_file = $source_mod.".pm";
    $source_file =~ s|::|/|g;

    eval {require $source_file} or die $@;
    push @ISA, $source_mod;
    my $self = 
    {
	'model' => $model,
	'cache' => $model->{'cache'},
    };
    bless ($self, $class);

#    die Dumper $self, \@ISA;

    $self->SUPER::init();
    return $self;
}


sub value
{
    my( $self, $new ) = @_;

    # Put in support for the Units part of value

    $self->{'simple'}{'value'} = $new if defined $new;
    

    my $value = $self->{'simple'}{'value'};
    if( not defined $value )
    {
	if( my $res = $self->get_objects( $self->model->rdf('value') ) )
	{
	    $value = $res->[0]{'simple'}{'value'};
	}
    }
    return $value;
}

sub value_list
{
    my( $self ) = @_;
    
    if( defined $self->value )
    {
	return [ $self->value ];
    }
    else
    {
	my $type_list = $self->get_objects( $self->model->rdf('type') );
	my $container = 0;
	foreach my $type ( @$type_list )
	{
	    my $uri = $type->uri;
	    $container++ if $uri eq $self->model->rdf('Bag')->uri;
	    $container++ if $uri eq $self->model->rdf('Alt')->uri;
	    $container++ if $uri eq $self->model->rdf('Seq')->uri;
	}
	$container or confess( $self->uri." has no value" );

	my @values = ();
	foreach my $obj ( @{ $self->get_membership_objects } )
	{
	    push @values, $obj->value || $obj->uri;
	}
	return \@values;
    }
}





sub uri   { $_[0]->{'simple'}{'uri'}  = $_[1] if defined $_[1]; $_[0]->{'simple'}{'uri'} }
sub lang  { $_[0]->{'simple'}{'lang'} = $_[1] if defined $_[1]; $_[0]->{'simple'}{'lang'} }

1;




